<?php
// ***************************************************************
// Program	SlashOrg Downloader API class
// Filename	inc_sorg_dl_api.php
// Version	0.1
// Last update	2006/03/24
//
// It allow websites to interact with the SlashOrg Download
// Manager.
//
// Send bug reports to dev@slashorg.net
// ***************************************************************

class sorgDLApi {

	var $link		= '';
	var $db_selected	= '';

	// **************************************************
	// This function connects the MySQL database.
	// Returns: 1 = OK, 0 = error
	// **************************************************

	function dbConnect ($dbHost, $dbName, $dbUser, $dbPassword) {

		if ($dbHost && $dbName && $dbUser) {

			// Let's see if we can connect to the database.
			if ($this->link = @mysql_connect($dbHost, $dbUser, $dbPassword)) {
				// Let's see if we can select the database.
				if ($this->db_selected = @mysql_select_db($dbName, $this->link)) {
					// No error.
					return 1;
				}
			}

		}

		// Oupps, something went wrong.
		return 0;
	}

	// **************************************************
	// Disconnect from database.
	// Returns: 1 = OK, 0 = error
	// **************************************************

	function dbDisconnect () {
		if ($this->db_selected) {
			mysql_close($this->link);
			return 1;
		} else {
			return 0;
		}
	}

	// **************************************************
	// This function creates a new shared folder based
	//    on supplied parameters:
	// $keyDuration - time given in seconds
	//    ("-1" means no expire)
	// $keyUses - number of times the key can be used
	//    ("-1" means unlimited)
	// $keyLockDir - directory key will grant access to.
	//    Don't forget trailing slash (ex: "share/dir/").
	//    ("" means no lock)
	// $keyLimitToIP - associate IP to key
	//    ("0.0.0.0" means no IP limit,
	//    "" means obtain IP of first user,
	//    or enter an IP address directly)
	// $keyIsAdmin - "1" means "yes", "0" means "no"
	// $keyCanCreateAccount - "1" means "yes",
	//    "0" means "no"
	// **************************************************

	function newSharedFolder ($keyDuration, $keyUses, $keyLockDir, $keyLimitToIP, $keyIsAdmin, $keyCanCreateAccount) {

		$start_date = time();
		$end_date = $keyDuration + $start_date;
		$hash = md5(microtime() + $start_date);

		// Build SQL query
		$sql = "INSERT INTO cgd_access VALUES ('', '$start_date', '$end_date', '$keyUses', '$hash', '$keyLockDir', '$keyLimitToIP', '$keyIsAdmin', '$keyCanCreateAccount', null)";

		// Run SQL query
		if(@mysql_query($sql, $this->link)) {
			// Query ran correctly, return hash key.
			return $hash;
		} else {
			// Oupps, something went wrong.
			return 0;
		}
	}

	// **************************************************
	// This function shows share information based
	//    on its hash.
	// Returns an array with the following elements:
	//    start_date, end_date, uses_left, dir, ip,
	//    is_admin, can_create_account
	// **************************************************

	function showSharedFolder ($keyHash) {

		// Build SQL query
		$sql = "SELECT start_date, end_date, uses_left, dir, ip, is_admin, can_create_account FROM cgd_access WHERE hash = '".$keyHash."'";

		// Run SQL query
		if($result = @mysql_query($sql, $this->link)) {
			if (!mysql_num_rows($result))
				// No such hash.
				return 0;

			return mysql_fetch_assoc($result);
		}

		return 0;
	}

	// **************************************************
	// This function removes a share based on its hash.
	// **************************************************

	function rmSharedFolder ($keyHash) {

		// Build SQL query
		$sql = "DELETE FROM cgd_access WHERE hash = '".$keyHash."'";

		// Run SQL query
		if(@mysql_query($sql, $this->link)) {
			if (mysql_affected_rows ($this->link))
				return 1;
		}

		return 0;
	}

}
?>
